#include "acceleration.h"
#include "iib.h"

#ifndef LINUX
__prog__ __attribute__((space(prog))) const float accel_curve[230] =
#else
const float accel_curve[230] =
#endif
    { 95.493, 47.746, 31.831, 23.873, 19.099, 15.915, 13.642, 11.937, 10.61, 9.549,
        8.681, 7.958, 7.346, 6.821, 6.366, 5.968, 5.617, 5.305, 5.026, 4.775,
        4.547, 4.341, 4.152, 3.979, 3.82, 3.673, 3.537, 3.41, 3.293, 3.183, 3.08,
        2.984, 2.894, 2.809, 2.728, 2.653, 2.581, 2.513, 2.449, 2.387, 2.329,
        2.274, 2.221, 2.17, 2.122, 2.076, 2.032, 1.989, 1.949, 1.91, 1.872, 1.836,
        1.802, 1.768, 1.736, 1.705, 1.675, 1.646, 1.619, 1.592, 1.565, 1.54, 1.516,
        1.492, 1.469, 1.447, 1.425, 1.404, 1.384, 1.364, 1.345, 1.326, 1.308, 1.29,
        1.273, 1.256, 1.24, 1.224, 1.209, 1.194, 1.179, 1.165, 1.151, 1.137, 1.123,
        1.11, 1.098, 1.085, 1.073, 1.061, 1.049, 1.038, 1.027, 1.016, 1.005, 0.995,
        0.984, 0.974, 0.965, 0.955, 0.945, 0.936, 0.927, 0.918, 0.909, 0.901,
        0.892, 0.884, 0.876, 0.868, 0.86, 0.853, 0.845, 0.838, 0.83, 0.823, 0.816,
        0.809, 0.802, 0.796, 0.789, 0.783, 0.776, 0.77, 0.764, 0.758, 0.752, 0.746,
        0.74, 0.735, 0.729, 0.723, 0.718, 0.713, 0.707, 0.702, 0.697, 0.692, 0.687,
        0.682, 0.677, 0.672, 0.668, 0.663, 0.659, 0.654, 0.65, 0.645, 0.641, 0.637,
        0.632, 0.628, 0.624, 0.62, 0.616, 0.612, 0.608, 0.604, 0.601, 0.597, 0.593,
        0.589, 0.586, 0.582, 0.579, 0.575, 0.572, 0.568, 0.565, 0.562, 0.558,
        0.555, 0.552, 0.549, 0.546, 0.543, 0.54, 0.536, 0.533, 0.531, 0.528, 0.525,
        0.522, 0.519, 0.516, 0.513, 0.511, 0.508, 0.505, 0.503, 0.5, 0.497, 0.495,
        0.492, 0.49, 0.487, 0.485, 0.482, 0.48, 0.477, 0.475, 0.473, 0.47, 0.468,
        0.466, 0.464, 0.461, 0.459, 0.457, 0.455, 0.453, 0.45, 0.448, 0.446, 0.444,
        0.442, 0.44, 0.438, 0.436, 0.434, 0.432, 0.43, 0.428, 0.426, 0.424, 0.423,
        0.421, 0.419, 0.417, 0.415 };

// Effeciency table for Torque [Nm] and Speed [kRPM]
#ifndef LINUX
__prog__ __attribute__((space(prog))) const float eff_curve[22][24] =
#else
const float eff_curve[22][24] =
#endif
    {
        { 0.30215, 0.33481, 0.34566, 0.41394, 0.48191, 0.51878, 0.55614, 0.57737, 0.59866, 0.61332, 0.62801, 0.6383, 0.6486, 0.65748, 0.66639, 0.67367, 0.68084, 0.68687, 0.69292, 0.69812, 0.70334, 0.70858, 0.71382, 0.71909 },
        { 0.30215, 0.33481, 0.34566, 0.41394, 0.48191, 0.51878, 0.55614, 0.57737, 0.59866, 0.61332, 0.62801, 0.6383, 0.6486, 0.65748, 0.66639, 0.67367, 0.68084, 0.68687, 0.69292, 0.69812, 0.70334, 0.70858, 0.71382, 0.71909 },
        { 0.36786, 0.42484, 0.453, 0.52289, 0.58989, 0.62275, 0.65614, 0.67355, 0.69105, 0.70306, 0.71512, 0.72309, 0.73109, 0.73793, 0.74479, 0.75044, 0.75583, 0.76039, 0.76495, 0.76891, 0.77288, 0.77686, 0.78085, 0.78485 },
        { 0.37525, 0.45754, 0.50827, 0.58317, 0.6516, 0.68414, 0.71728, 0.73403, 0.75089, 0.76284, 0.77487, 0.78249, 0.79015, 0.79641, 0.8027, 0.80794, 0.81272, 0.81678, 0.82085, 0.8244, 0.82796, 0.83152, 0.8351, 0.83867 },
        { 0.36006, 0.4564, 0.52376, 0.60219, 0.67132, 0.70417, 0.73772, 0.75434, 0.7711, 0.78343, 0.79585, 0.8035, 0.81117, 0.8173, 0.82344, 0.82864, 0.83321, 0.83714, 0.84108, 0.84455, 0.84803, 0.85152, 0.85502, 0.85852 },
        { 0.33563, 0.44508, 0.52897, 0.61225, 0.68335, 0.71736, 0.75216, 0.76921, 0.78644, 0.79953, 0.81273, 0.82068, 0.82867, 0.83486, 0.84106, 0.8464, 0.85093, 0.85485, 0.85879, 0.8623, 0.86581, 0.86934, 0.87287, 0.8764 },
        { 0.31161, 0.4282, 0.52424, 0.61156, 0.68454, 0.71991, 0.75617, 0.77385, 0.79172, 0.80571, 0.81982, 0.8282, 0.83663, 0.84302, 0.84944, 0.85503, 0.85963, 0.86367, 0.86772, 0.87136, 0.87502, 0.87868, 0.88234, 0.88602 },
        { 0.28841, 0.40798, 0.51305, 0.60385, 0.67863, 0.71551, 0.75336, 0.77178, 0.79043, 0.80538, 0.82048, 0.82938, 0.83832, 0.84501, 0.85172, 0.85765, 0.86241, 0.86663, 0.87086, 0.87471, 0.87856, 0.88243, 0.8863, 0.89018 },
        { 0.2643, 0.38611, 0.49955, 0.59398, 0.67084, 0.70938, 0.74899, 0.76826, 0.78778, 0.80377, 0.81991, 0.82937, 0.83889, 0.84591, 0.85296, 0.85926, 0.8642, 0.86863, 0.87307, 0.87714, 0.88122, 0.88531, 0.8894, 0.89351 },
        { 0.24689, 0.36762, 0.48528, 0.58186, 0.66014, 0.7001, 0.7412, 0.76117, 0.78141, 0.79827, 0.81529, 0.82525, 0.83527, 0.84261, 0.84998, 0.85663, 0.86177, 0.86641, 0.87106, 0.87535, 0.87965, 0.88396, 0.88829, 0.89262 },
        { 0.22877, 0.34816, 0.46987, 0.56875, 0.64863, 0.6901, 0.73279, 0.75353, 0.77456, 0.79232, 0.81026, 0.82075, 0.83131, 0.83899, 0.8467, 0.85371, 0.85906, 0.86392, 0.8688, 0.87333, 0.87786, 0.88241, 0.88697, 0.89154 },
        { 0.2111, 0.32782, 0.45202, 0.55271, 0.63406, 0.67709, 0.72142, 0.74305, 0.76498, 0.78377, 0.80275, 0.81385, 0.82503, 0.83314, 0.84129, 0.84876, 0.85438, 0.85952, 0.86468, 0.86949, 0.87432, 0.87917, 0.88402, 0.88888 },
        { 0.19373, 0.30683, 0.43247, 0.53464, 0.61741, 0.66203, 0.70804, 0.73063, 0.75356, 0.77345, 0.79354, 0.80532, 0.81718, 0.82579, 0.83444, 0.84242, 0.84835, 0.85381, 0.85929, 0.86444, 0.8696, 0.87478, 0.87996, 0.88516 },
        { 0.17611, 0.2842, 0.40918, 0.51248, 0.59685, 0.64325, 0.69115, 0.71492, 0.73907, 0.7602, 0.78156, 0.79416, 0.80686, 0.81606, 0.82531, 0.83389, 0.84022, 0.84609, 0.85197, 0.85752, 0.86309, 0.86866, 0.87425, 0.87986 },
        { 0.1601, 0.26279, 0.38609, 0.48991, 0.57552, 0.62356, 0.67322, 0.69816, 0.72352, 0.74588, 0.76851, 0.78197, 0.79554, 0.80535, 0.81521, 0.8244, 0.83116, 0.83745, 0.84377, 0.84974, 0.85573, 0.86174, 0.86776, 0.8738 },
        { 0.14394, 0.24024, 0.36037, 0.46389, 0.55045, 0.60005, 0.65141, 0.67767, 0.70439, 0.72815, 0.75219, 0.7666, 0.78112, 0.79162, 0.80218, 0.81206, 0.81905, 0.82555, 0.83208, 0.83827, 0.84447, 0.85069, 0.85692, 0.86318 },
        { 0.12919, 0.21942, 0.3366, 0.43926, 0.5261, 0.57695, 0.62966, 0.65713, 0.68509, 0.71019, 0.7356, 0.75088, 0.76629, 0.77745, 0.78867, 0.79923, 0.80622, 0.81274, 0.81929, 0.82549, 0.83171, 0.83794, 0.8442, 0.85047 },
        { 0.11487, 0.19816, 0.31015, 0.41086, 0.49743, 0.54939, 0.60333, 0.63211, 0.66144, 0.68796, 0.71483, 0.73109, 0.74748, 0.75944, 0.77147, 0.78284, 0.78886, 0.79441, 0.79996, 0.80518, 0.81041, 0.81565, 0.8209, 0.82617 },
        { 0.10028, 0.17589, 0.28145, 0.37936, 0.46512, 0.51799, 0.573, 0.6031, 0.63381, 0.66179, 0.69016, 0.70751, 0.72502, 0.73788, 0.75082, 0.76309, 0.76429, 0.76497, 0.76564, 0.76595, 0.76625, 0.76655, 0.76684, 0.76712 },
        { 0.086867, 0.15465, 0.2529, 0.34709, 0.43132, 0.48471, 0.54038, 0.57169, 0.60367, 0.633, 0.66275, 0.68124, 0.69991, 0.70087, 0.70181, 0.70201, 0.7034, 0.7043, 0.70519, 0.70573, 0.70626, 0.70679, 0.70731, 0.70783 },
        { 0.075418, 0.13621, 0.22777, 0.31793, 0.40012, 0.45366, 0.5096, 0.54188, 0.5749, 0.60537, 0.63631, 0.65584, 0.67556, 0.65177, 0.62775, 0.60284, 0.61194, 0.62063, 0.62937, 0.63781, 0.64629, 0.65479, 0.66333, 0.6719 },
        { 0.064985, 0.1196, 0.20565, 0.292, 0.37195, 0.42552, 0.48151, 0.51461, 0.54847, 0.57998, 0.61198, 0.63243, 0.65308, 0.6044, 0.55526, 0.50512, 0.52184, 0.53827, 0.55478, 0.57109, 0.58745, 0.60388, 0.62038, 0.63694 }
    };

uint16_t get_accel_curve(int i)
{
    AMK_Inverter* inv = &iib.inv[i];
    InverterLimits* lim = &iib.iib_safety.inv_lim[i];
    int16_t krpm = inv->actual_speed / 1000;
    uint16_t torque = iib.dsr[i].t_p / 1000;

    if (torque > 21 && krpm > 23) {
        return *(lim->max_op_pwr) * eff_curve[21][23] / RAD(23);
    } else if (torque > 21) {
        return *(lim->max_op_pwr) * eff_curve[21][krpm] / RAD(krpm);
    } else if (krpm > 23) {
        return *(lim->max_op_pwr) * eff_curve[torque][23] / RAD(23);
    }

    float curve_value = eff_curve[torque][krpm];

    float torque_value = *(lim->max_op_pwr) * curve_value / RAD(krpm);

    if (torque_value > *(lim->max_op_t)) {
        return *(lim->max_op_t);
    }

    return (uint16_t)torque_value;
}

int16_t get_brake_curve(int i)
{
    AMK_Inverter* inv = &iib.inv[i];
    InverterLimits* lim = &iib.iib_safety.inv_lim[i];
    int16_t krpm = inv->actual_speed / 1000;
    uint16_t torque = -1 * iib.inv[i].setp.t_n / 1000;

    if (torque > 21 && krpm > 23) {
        return -1 * ((int16_t) * (lim->max_op_reg_pwr) * eff_curve[21][23] / RAD(23));
    } else if (torque > 21) {
        return -1 * ((int16_t) * (lim->max_op_reg_pwr) * eff_curve[21][krpm] / RAD(krpm));
    } else if (krpm > 23) {
        return -1 * ((int16_t) * (lim->max_op_reg_pwr) * eff_curve[torque][23] / RAD(23));
    }

    float curve_value = eff_curve[torque][krpm];

    float torque_value = *(lim->max_op_reg_pwr) * curve_value / RAD(krpm);

    if (torque_value > *(lim->max_op_reg_t)) {
        return -1 * ((int16_t) * (lim->max_op_reg_t));
    }

    return -1 * ((int16_t)torque_value);
}
